function string_to_slug(str) {
  str = str.replace(/^\s+|\s+$/g, ''); // trim
  str = str.toLowerCase();

  // remove accents, swap ñ for n, etc
  var from = 'àáäâèéëêìíïîòóöôùúüûñç·/_,:;';
  var to = 'aaaaeeeeiiiioooouuuunc------';
  for (var i = 0, l = from.length; i < l; i++) {
    str = str.replace(new RegExp(from.charAt(i), 'g'), to.charAt(i));
  }

  str = str.replace(/[^a-z0-9 -]/g, '') // remove invalid chars
  .replace(/\s+/g, '-') // collapse whitespace and replace by -
  .replace(/-+/g, '-'); // collapse dashes
  return str;
}

// Sidebar Items
exports.items = [{
  name: 'Item 1',
  link: 'http://link1'
},
{
  name: 'Item 2',
  link: 'http://link2'
}];

// Blog posts
var posts = [{
  id: 'new-blog-post-1',
  title: 'Post 1',
  date: '2012-01-16',
  summary: 'New blog post 1',
  content: 'Test text for post 1'
},
{
  id: 'new-blog-post-2',
  title: 'Post 2',
  date: '2012-01-17',
  summary: 'New blog post 2',
  content: 'Test text for post 2'
}];

function findMany(quantity, callback) {
  callback(posts);
}
exports.findMany = findMany;

function findOne(id, callback) {
  for (var i=0; i<posts.length; i++) {
    if (posts[i].id === id) { 
      callback(posts[i]);
      return
    }
  }
  callback(undefined);
}
exports.findOne = findOne;

