var util = require('util');
var express = require('express');
var socketio = require('socket.io');

var dataProvider = require('./dataProvider.js');

var server = express.createServer();
var io = socketio.listen(server);

server.configure(function() {
  server.use(express.static(__dirname + '/static'));
  server.use(server.router);
});

// Server routes
server.get('/', function(req, res) {
  res.sendfile(__dirname + '/index.html');
});

server.get('/api/sidebar.:format?', function(req, res) {
  console.log('Get on sidebar items');
  switch (req.params.format) {
    case 'json':
      res.send({
      item:
        dataProvider.items
    });
    break;

    default:
      res.send('Format not available', 400);
  }
});

server.get('/api/posts.:format?', function(req, res) {
  console.log('Get on posts');
  console.log(req.params.format);
  switch (req.params.format) {
    case 'json':
      dataProvider.findMany(10, function(result) {
      res.send(result);
    });
    break;
    default:
      res.send('Format not available', 400);
  }
});

server.get('/api/posts.:format?/:id', function(req, res) {
  console.log('Get on specific post in format ' + req.params.format + '. Post id: ' + req.params.id + '.');
  switch (req.params.format) {
    case 'json':
      dataProvider.findOne(req.params.id, function(data) {
      res.send(data);
    });
    break;

    default:
      res.send('Format not available', 400);
  }
});

//server.get('/post/:page', function(req, res) {
//res.redirect('/#/post/' + req.params.page);
//});
server.get('*', function(req, res) {
  res.send('404 - Not Found', 404);
});

// Websocket events
io.sockets.on('connection', function(socket) {
  //Emit on connection start
  //socket.emit('sidebar-items', {
  //item: dataProvider.items
  //});
  // Get individual post
  socket.on('get-post', function(data) {
    dataProvider.findOne(data.post, function(result) {
      if (result === undefined) {
        dataProvider.findMany(quantity, function(result) {
          socket.emit('posts', {
            posts: result
          });
        });
      } else {
        socket.emit('post', {
          post: result
        });
      };
    });
  });

  // Get recent posts
  socket.on('last-posts', function(data) {
    console.log('Client requested last ' + data.quantity + ' posts.');
    // TODO: Use data.quantity
    dataProvider.findMany(data.quantity, function(result) {
      socket.emit('posts', {
        posts: result
      });
    });
  });
});

server.listen(8000);

